

/*
 Brett Oliver
 
 http://www.brettoliver.org.uk
//
//  Copyright 2018 Brett Oliver
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program. If not, see http://www.gnu.org/licenses/
// based on original project here https://create.arduino.cc/projecthub/user0035382/clock-with-alarm-hygrometer-thermometer-531acb
//
################  Added version number line 572 ###############
v7.0 put delays back in menu and add read temp humidity after exit clock set
*/





//###################################################################################################



#include <Adafruit_ST7735.h>
#include <Adafruit_GFX.h>
#include <Wire.h>
#include <SPI.h>
#include "EEPROM.h"

#define TFT_CS     9
#define TFT_RST    12  //was 7 changed for wiring convenience only                  
#define TFT_DC     8
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

// Option 2: use any pins but a little slower!
#define TFT_SCLK 13   // set these to be whatever pins you like!
#define TFT_MOSI 11   // set these to be whatever pins you like!



//Brett
float maxTemperature=0;
float previousmaxTemperature = 0;
float minTemperature=200;
float previousminTemperature = 200;
char charMinTemperature[10];
char charMaxTemperature[10];

char secChar [10];
char timeChar[100];
char dateChar[50];
char temperatureChar[10];

char AdvRtdSetChar[10];
char adjCountChar[10];
char backoffcountChar[10];
float temperature = 0;
float previousTemperature = 0;

//String dateString;
int minuteNow=0;
int minutePrevious=0;

int extraLength = 500; //Length of extra pulse
int pulseLength = 400; // sets lenth of pulse by adjusting  delay max 400 min 50
int pulsePin = A6; // Pin for sensing pusle length value
int pulsePinval = 0;



#define DS3231_I2C_ADDRESS 104
byte tMSB, tLSB;
float temp3231;
byte hh, mm, ss;
byte yy, ll, dd, zz;

#define menu 2 
#define minus 3
#define plus 4

#define syncPulse 5
#define backlight 10
int nivel = 0;   // if is 0 - clock
                 // if is 1 - hour adjust
                 // if is 2 - minute adjust

int hh1, mm1, zz1, dd1, ll1, yy1;   
int maxday;
boolean initial = 1;
boolean initialtemp = 1;
char chartemp[3];

//byte xa = 80;
//byte ya = 70;

#include "DHT.h"
#define DHTPIN 16     // what pin we're connected to
// Uncomment whatever type you're using!
//#define DHTTYPE DHT11   // DHT 11 
#define DHTTYPE DHT22   // DHT 22  (AM2302)
//#define DHTTYPE DHT21   // DHT 21 (AM2301)
// Connect pin 1 (on the left) of the sensor to +5V
// NOTE: If using a board with 3.3V logic like an Arduino Due connect pin 1
// to 3.3V instead of 5V!
// Connect pin 2 of the sensor to whatever your DHTPIN is
// Connect pin 4 (on the right) of the sensor to GROUND
// Connect a 10K resistor from pin 2 (data) to pin 1 (power) of the sensor

// Initialize DHT sensor for normal 16mhz Arduino
DHT dht(DHTPIN, DHTTYPE);
// NOTE: For working with a faster chip, like an Arduino Due or Teensy, you
// might need to increase the threshold for cycle counts considered a 1 or 0.
// You can do this by passing a 3rd parameter for this threshold.  It's a bit
// of fiddling to find the right value, but in general the faster the CPU the
// higher the value.  The default for a 16mhz AVR is a value of 6.  For an
// Arduino Due that runs at 84mhz a value of 30 works.
// Example to initialize DHT sensor for Arduino Due:
//DHT dht(DHTPIN, DHTTYPE, 30);
//float temperatura;
int umiditate;
int tzeci, tunit, tzecimi, trest;
int tsemn, ttot;
int hzeci, hunit;
int previousHumidity = 0;
char umiditateChar[10];



//Brett
int secondsNow = 0;
int secondsOld = 0;
int AdvRtdPin = A0; //Pin for sensing advance/retard setting
int AdvRtdVal = 0; // Analogue value 0-1023
int AdvRtdSet = 0; // Advance retard pulses
int previousAdvRtdSet = 0; 
//int secsMiss = 0;    // used for calculating gained or missed seconds
int secondssync = 0; //records seconds when sync pulse received
int adjCount = 0; // set to number of pulses from rotary switch value AdvRtdSet
int previousadjCount = 0;
int backlightNow = 0;
int backlightOld = 0;
int backlightcount = 0;
boolean backlightOn = true; //When true backlight timer in progress
int backoffcount = 300;


boolean coilStatus    = false;  // clock coil status
boolean retard        = false;  // true if clock going back
boolean advance       = true;  // false when AdvRtdSetUse is in use for counting advance/retard pulse values
boolean clockRun      = true;   // when false clock motor will stop used for retard and sync
boolean AdvRtdSetUse  = true;  // true if clock going back
boolean nosync        = true; // true allows sync secs to be recorded
boolean sumwin        = false; // true when setting sum win time


const int clockCoil01 = A1;                    // (A1) clock coil
const int clockCoil02 = A3;                    // (A3) clock coil 
const int retardSw = 7;   // was 12 was 7 changed for wiring convenience only                // (D10) input for winter retard
const int advanceSw = 6;                    // (D12) input for summer advance




//Brett



void setup () 
{
    dht.begin(); 
    tft.initR(INITR_BLACKTAB);
    tft.fillScreen(ST7735_BLACK);
//  Serial.begin(9600);
    Wire.begin();
pinMode(menu, INPUT_PULLUP); 
pinMode(plus, INPUT_PULLUP); 
pinMode(minus, INPUT_PULLUP); 
pinMode(syncPulse, INPUT); 
pinMode(backlight, OUTPUT);

pinMode(AdvRtdPin, INPUT);
pinMode(pulsePin, INPUT);


pinMode(retardSw, INPUT_PULLUP);
pinMode(advanceSw, INPUT_PULLUP);

pinMode(clockCoil01, OUTPUT);
pinMode(clockCoil02, OUTPUT);

digitalWrite(menu, HIGH);  // put inputs in high state (when push is to ground -> low state)
digitalWrite(plus, HIGH);
digitalWrite(minus, HIGH);

digitalWrite(backlight, HIGH);
  

// setDS3231time(byte second, byte minute, byte hour, byte dayOfWeek, byte dayOfMonth, byte month, byte year);
//setDS3231time(0, 45, 13, 0, 25, 11, 2016;





}


void loop () //#####################################################################
{
if (nivel == 0)
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  hh1=hh;
  mm1=mm;
  zz1=zz;
  yy1=yy;
  ll1=ll;
  dd1=dd;
  //delay(21);//Brett
  tft.fillScreen(ST7735_BLACK);
  tft.fillRect(0,0,128,160,ST7735_BLACK);
 
  }

readDS3231time(&ss, &mm, &hh, &zz, &dd, &ll,&yy);
  
// Check for sync pulse on pin 5
if (digitalRead(syncPulse) == HIGH)
{
   printText("SYNC", ST7735_YELLOW,95,25,1); 
}

else
{
  tft.fillRect(82,25,44,7,ST7735_BLACK);
}


    

// Changed to Manual sync to 30 seconds only



if (digitalRead(syncPulse) == HIGH  && !advance && !retard && nosync == true )// sync on 30seconds as long as clock not advancing or retarding
{ 
   
 
  nosync = false ;
   setDS3231time(30, mm, hh, zz, dd, ll, yy); //Set seconds to 30 on RTC

      

       
  
     String hours = "";
    if(hh<10)
    {
         hours = hours+" "+String(hh);
    }else  
    hours = hours+ String(hh);
    if(mm<10)
   {
        hours = hours+" 0"+String(mm)+String(" ");
    }else
    {
        hours = hours+" "+String(mm)+String(" ");
    } 

    hours.toCharArray(timeChar,100);


   //Brett ss display

   String sec = "";
    if(ss<10)
    
    {
        sec = +"0"+String(ss);
    }else
    {
       sec = String(ss);
    }

    sec.toCharArray(secChar,10);

  
   

    

    tft.fillRect(25,39,103,7,ST7735_BLACK);
    
  // Print time
    printText(timeChar, ST7735_YELLOW,25,39,1);//Brett time changed to small font
    printText(secChar, ST7735_YELLOW,60,39,1);//Brett seconds only
   printText(":", ST7735_YELLOW,37,39,1);//Brett added colon
    printText(":", ST7735_YELLOW,55,39,1);//Brett added colon


    //Print date
     String dayOfMonth = "";

dayOfMonth = dayOfMonth+String(dd)+"/"+String(ll)+"/"+String(yy);


dayOfMonth.toCharArray(dateChar,50);
    
printText(dateChar, ST7735_YELLOW,77,39,1);//Brett day
    

}







 
 //Brett
//Check every second
 
  minuteNow = ss;// Brett was mm
  if(minuteNow!=minutePrevious || initial)
  {
    initial = 0;
 
    minutePrevious = minuteNow;
    String hours = "";
    if(hh<10)
    {
         hours = hours+" "+String(hh);
    }else  
    hours = hours+ String(hh);
    if(mm<10)
    {
        hours = hours+" 0"+String(mm)+String(" ");
    }else
    {
        hours = hours+" "+String(mm)+String(" ");
    }

    hours.toCharArray(timeChar,100);


// Set pulse length
PulseSettings();


//Brett ss display

   String sec = "";
    if(ss<10)
    
    {
        sec = +"0"+String(ss);
    }else
    {
       sec = String(ss);
    }

    sec.toCharArray(secChar,10);


 

 if ( ss > 31 )
   {
      nosync = true ;
   }


//End of record non sync time

temphumidread();//

/*
if ( (ss == 15 && (mm == 15 || mm == 30 || mm == 45 || mm == 1) && advance == 0 ) || initialtemp)// read temp & humidity every 1min @ 15seconds past but not when advancing
{
temperature = dht.readTemperature();
umiditate = dht.readHumidity();


// Brett check min max temp

 if ((temperature != previousTemperature) || initial)
  {
    previousTemperature = temperature;
    String temperatureString = String(temperature,1);
    temperatureString.toCharArray(temperatureChar,10);
    tft.fillRect(25,53,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(temperatureChar, ST7735_GREEN,25,53,1); // Across Down Font size 
    printText("o", ST7735_GREEN,49,51,1);
    printText("C", ST7735_GREEN,55,53,1);

  if((umiditate != previousHumidity) || initial)
  {
    previousHumidity = umiditate;
    String umiditateString = String(umiditate);
    umiditateString.toCharArray(umiditateChar,10);
    tft.fillRect(70,53,40,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(umiditateChar, ST7735_GREEN,90,53,1);
    printText("%", ST7735_GREEN,103,53,1);
  }
  }

 if (hh == 0 && mm == 0 && ss == 0)// resets min max temps at midnight
 {
  previousmaxTemperature = 1;
  previousminTemperature = 200;
 }

 
//Brett Temp Min Max
   maxTemperature = temperature ;
 if ((maxTemperature > previousmaxTemperature) || initialtemp)
  {
    previousmaxTemperature = maxTemperature;
    String maxTemperatureString = String(maxTemperature,1);
    maxTemperatureString.toCharArray(charMaxTemperature,10);
    tft.fillRect(25,67,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(charMaxTemperature, ST7735_RED,25,67,1); // Across Down Font size 
    printText("o", ST7735_RED,49,65,1);
    printText("C", ST7735_RED,55,67,1);
  }
    minTemperature = temperature ;

     
  
  if ((minTemperature < previousminTemperature) || initialtemp )
  {
    previousminTemperature = minTemperature;
     String minTemperatureString = String(minTemperature,1);
    minTemperatureString.toCharArray(charMinTemperature,10);
    tft.fillRect(90,67,25,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(charMinTemperature, ST7735_BLUE,90,67,1);
    printText("o", ST7735_BLUE,114,65,1);
    printText("C", ST7735_BLUE,120,67,1);
    
  }
 
 initialtemp = 0 ;
}
*/
 // Brett check min max temp 






    
   
    tft.fillRect(34,25,48,7,ST7735_BLACK);
//Brett test Across, Down, Width, Hieght####################################
  
    printText(timeChar, ST7735_YELLOW,35,25,1);//Brett time changed to small font
    printText("Time", ST7735_YELLOW,5,25,1);//Brett added word TIME
   printText(":", ST7735_YELLOW,47,25,1);//Brett added colon
    printText(":", ST7735_YELLOW,65,25,1);//Brett added colon
     printText(secChar, ST7735_YELLOW,70,25,1);//Brett seconds only
    
    
    //dateString.toCharArray(dateChar,50);
   // printText(dateChar, ST7735_GREEN,8,5,1);

   printText("PRAGOTRON", ST7735_GREEN,35,0,1);// Across Down Font size

// Brett alternate 2nd row of title
   if ( (ss % 2) == 0) 
  { 
   tft.fillRect(0,9,127,9,ST7735_BLACK);
   printText("Time Control v7.0", ST7735_GREEN,0,9,1);// Across Down Font size
  }
  else
  {
   tft.fillRect(0,9,127,9,ST7735_BLACK);
   printText("Display Timeout", ST7735_GREEN,0,9,1);// Across Down Font size
   String backoffcountString = String(backoffcount);
    backoffcountString.toCharArray(backoffcountChar,10);
     
   tft.fillRect(100,9,20,9,ST7735_BLACK);
    printText(backoffcountChar, ST7735_GREEN,100,9,1);
  
  }
  // Brett end alternate 2nd row of title

  
    printText("Sync", ST7735_YELLOW,0,39,1); // Shows last sync time
    printText("Temp", ST7735_GREEN,0,53,1);  // Temperature Static Text
    printText("Hum", ST7735_GREEN,70,53,1);
    printText("Max", ST7735_RED,0,67,1);  // Temperature Static Text
    printText("Min", ST7735_BLUE,70,67,1);
    

    
     printText("CONTROL", ST7735_GREEN,0,88,1);
   printText("Advance/Retard", ST7735_GREEN,0,102,1);// Across Down Font size
    printText("Pulses", ST7735_GREEN,0,116,1);
    printText("Pulses to go", ST7735_GREEN,0,130,1);


// Brett print ADVANCING or RETARDING CLOCKS on TFT


if (advance == true)
    {
     tft.fillRect(0,143,127,15,ST7735_BLACK);
      printText("ADVANCING CLOCKS", ST7735_GREEN,10,143,1);
      printText("Press Rtd to Cancel", ST7735_GREEN,0,151,1);
    }
    else if (retard == true)
    {
     tft.fillRect(0,143,127,15,ST7735_BLACK);
      printText("RETARDING CLOCKS", ST7735_GREEN,10,143,1);
      printText("Press Adv to Cancel", ST7735_GREEN,3,151,1);
   }
   else 
   {
  tft.fillRect(0,143,128,15,ST7735_BLACK);
   printText("Press Adv or Rtd", ST7735_GREEN,0,144,1);
   }

   
// Brett print ADVANCING or RETARDING CLOCKS on TFT

// Brett amalagamated 1 sec loop
 // Brett do every second

 
//secondsNow = ss;


// if (secondsNow != secondsOld )
// {
// Man advance/retard

 if (digitalRead(retardSw) == LOW || digitalRead(advanceSw) == LOW && AdvRtdSetUse == true )
 {
   adjCount = AdvRtdSet;
   AdvRtdSetUse = false;

 }

 
 
      

 if (digitalRead(retardSw) == LOW || (retard == 1 && adjCount > 0)) //summer to winter clock goes back (misses AdvRtdSet number of pulses)
 {   
      retard = true;
    //   if (  adjCount != 5000)// adjcount 5000 stop
   //   {
      adjCount--;
      if ( sumwin == true && adjCount == 1)// summer winter selected retard RTC as wellwhen count gets to 1
      {
         hh = hh-1;
         setDS3231time(ss, mm, hh, zz, dd, ll, yy); //Set seconds to 30 on RTC
      }
    //  }

     
     
    }
    else if (digitalRead(advanceSw) == LOW || (advance == 1 && adjCount > 0)) //winter to summer clock goes forward (AdvRtdSet number of pulses)
    {   
      advance = true;
   //   if (  adjCount != 5000)// adjcount 5000 continous run
   //   {
      adjCount--;
      if ( sumwin == true && adjCount == 1)// summer winter selected retard RTC when count gets to 1
      {
         hh = hh+1;
         setDS3231time(ss, mm, hh, zz, dd, ll, yy); //Set seconds to 30 on RTC
   //   }
      }
     // AdvRtdSetUse = true;
    }
    
    else
    {
      adjCount = AdvRtdSet;
      retard = false;
      advance = false;
      AdvRtdSetUse = true;
      sumwin == false;
    }


//Brett cancel advance/retard

 if (digitalRead(advanceSw) == LOW && retard == true && adjCount > 1)
 {
  clockRun = true;
  adjCount = 0;
 }
else if (digitalRead(retardSw) == LOW && advance == true && adjCount > 1)
{
 
adjCount = 0;

}



// Brett add pulses remaining to display

if((adjCount != previousadjCount) || initial)
{
 String adjCountString = String(adjCount);
    adjCountString.toCharArray(adjCountChar,10);
    tft.fillRect(80,130,30,7,ST7735_BLACK);
    printText(adjCountChar, ST7735_GREEN,80,130,1);
   
}

// Brett end add pulses remaining to display



 
 //Brett  process for missed\gained seconds and pulse clock coil inc advance (now only corrects seonds at 28 (-2) and 32 (+2)

 
  if ( retard == true) // do nothing clock being retared
  {
    // serial.println ("do nothing");
  }

  else if ( advance == true) // step normal 1 sec pulse and advance pulse
  {
     
     pulseCoil(); // normal 1 sec clock motor pulse
     extraPulse(); 

  // serial.println ("advance in operation #######################");
  }
 
  else if ( !retard && !advance && clockRun == true) // Normal pulse 
  {
    // serial.println ("0 option");
    pulseCoil(); // normal 1 sec clock motor pulse
  
  secondssync = 0;

  }
  
 

 secondsOld = secondsNow ;


 
 
// Brett Get Advance /Retard settings from pot
if (!advance || !retard) // only allows reading of pot when not advancing or retarding. Test fix for display staying on when pot is turned during advance/retard
{
 AdvRtdSettings();
}
// End Get Advance /Retard settings from pot

 //####################################################

// Brett add pulses to display

if((AdvRtdSet != previousAdvRtdSet) || initial || AdvRtdSet == 0 )
{
 String AdvRtdSetString = String(AdvRtdSet);
    AdvRtdSetString.toCharArray(AdvRtdSetChar,10);
    tft.fillRect(40,116,30,7,ST7735_BLACK);
    printText(AdvRtdSetChar, ST7735_GREEN,40,116,1);
   
}


 




// Brett end amalagamated 1 sec loop
// Start Backlight control

backlightNow = AdvRtdSet;

 if ( advance || retard ) // turns on display if advancing or retarding
 { 
  digitalWrite(backlight, HIGH);
  backlightOn = true; // after advance/retard disply stays on for n seconds
  //backlightcount =  0;
 // Serial.println ("backlight advance or retard on ");
 }

 else 
 {
 if (backlightNow != backlightOld || backlightOn == true  ) // if control knob rotated  backlight comes on for n seconds
  {
   // initial = 0;
  backlightOld = backlightNow;
  digitalWrite(backlight, HIGH);
  backlightOn = true;
  //Serial.println ("backlight on ");
  backlightcount ++;
  backoffcount = 300-backlightcount;
  
  }

  if ( backlightcount == 300) // turns off backlight after n second counts This number is the number of seconds the display stays on for
  {
   backlightcount = 0;
   digitalWrite(backlight, LOW);
   backlightOn = false;
   
   
  
    
  }
 
 }
// End Backlight control
    





     
  }
  
 
  

 



//Brett Temp Min Max







} // end usual case (clock)


if (nivel == 1)   // change hours
{
if (digitalRead(menu) == LOW)
  {
     digitalWrite(backlight, HIGH); // keeps backlight on
  nivel = nivel+1;
   delay(150);//brett
  tft.fillScreen(ST7735_BLACK);
  tft.fillRect(0,0,128,160,ST7735_BLACK);
  }    

printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
printText("HOUR:", ST7735_GREEN,10,36,2);  // Temperature Static Text
dtostrf(hh1,3, 0, chartemp); 
      //tft.fillRect(50,50,70,18,ST7735_BLACK);
      tft.fillRect(50,50,70,38,ST7735_BLACK);
      delay(50);
      printText(chartemp, ST7735_WHITE,60,50,2);
      delay(50);
      
if (digitalRead(plus) == LOW)
    {
    hh1 = hh1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    hh1 = hh1-1;
    delay(150);
    }    
if (hh1 > 23) hh1 = 0;
if (hh1 < 0) hh1 = 23;       
     
}  // end loop nivel = 1 (change the hours)

if (nivel == 2)   // change minutes
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  delay(150);//brett
  tft.fillScreen(ST7735_BLACK);
  tft.fillRect(0,0,128,160,ST7735_BLACK);
  }    

printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
tft.fillRect(10,35,70,18,ST7735_BLACK);
printText("MINUTE:", ST7735_GREEN,10,35,2);  // Temperature Static Text
// serial.println(mm1);
dtostrf(mm1,3, 0, chartemp); 
      tft.fillRect(50,50,70,18,ST7735_BLACK);
      delay(50);
      printText(chartemp, ST7735_WHITE,60,50,2);
      delay(50);
     
if (digitalRead(plus) == LOW)
    {
    mm1 = mm1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    mm1 = mm1-1;
    delay(150);
    }    
if (mm1 > 59) mm1 = 0;
if (mm1 < 0) mm1 = 59;       
     
}  // end loop nivel = 2 (change the minutes)

if (nivel == 3)   // change day in week
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  delay(150);// Brett was 500
  tft.fillScreen(ST7735_BLACK);
  tft.fillRect(0,0,128,160,ST7735_BLACK);
  }    

printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
tft.fillRect(0,35,128,18,ST7735_BLACK);
printText("Day in Week:", ST7735_GREEN,10,40,1);  // Temperature Static Text
//Serial.println(mm1);
dtostrf(zz1,3, 0, chartemp); 
      tft.fillRect(50,50,70,18,ST7735_BLACK);
      delay(50);
      printText(chartemp, ST7735_WHITE,60,50,2);
tft.fillRect(10,80,100,18,ST7735_BLACK);      
if (zz1 == 1) printText("1 - Monday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 2) printText("2 - Tuesday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 3) printText("3 - Wednesday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 4) printText("4 - Thursday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 5) printText("5 - Friday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 6) printText("6 - Saturday", ST7735_GREEN,10,80,1);  // Temperature Static Text
if (zz1 == 0) printText("0 - Sunday", ST7735_GREEN,10,80,1);  // Temperature Static Text  
    delay(50);
     
if (digitalRead(plus) == LOW)
    {
    zz1 = zz1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    zz1 = zz1-1;
    delay(150);
    }    
if (zz1 > 6) zz1 = 0;
if (zz1 < 0) zz1 = 6;       
     
}  // end loop nivel = 3 (change the day of the week)

if (nivel == 4)   // change year
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  delay(150);//brett
  tft.fillScreen(ST7735_BLACK);
  tft.fillRect(0,0,128,160,ST7735_BLACK);
  tft.fillRect(10,80,100,18,ST7735_BLACK);    
  }    

printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
tft.fillRect(10,35,70,18,ST7735_BLACK);
printText("YEAR:", ST7735_GREEN,10,35,2);  // Temperature Static Text
dtostrf(yy1,3, 0, chartemp); 
      tft.fillRect(40,50,80,18,ST7735_BLACK);
      tft.fillRect(10,80,100,18,ST7735_BLACK);  // erase last explication...
      delay(50);
      printText("20", ST7735_WHITE,45,50,2);
      printText(chartemp, ST7735_WHITE,60,50,2);
      delay(50);

     
if (digitalRead(plus) == LOW)
    {
    yy1 = yy1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    yy1 = yy1-1;
    delay(150);
    }    
if (yy1 > 49) yy1 = 49;
if (yy1 < 16) yy1 = 16;       
     
}  // end loop stare = 4 (change the year)


if (nivel == 5)   // change mounth
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  delay(150);//brett
  tft.fillScreen(ST7735_BLACK);
   tft.fillRect(10,80,100,18,ST7735_BLACK);    
  }    
printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
tft.fillRect(10,35,70,18,ST7735_BLACK);
printText("MONTH:", ST7735_GREEN,10,35,2);  // Temperature Static Text
dtostrf(ll1,3, 0, chartemp); 
      tft.fillRect(40,50,80,18,ST7735_BLACK);
      tft.fillRect(10,80,100,18,ST7735_BLACK);  // erase last explication...
      delay(50);
      printText(chartemp, ST7735_WHITE,60,50,2);
      delay(50);
     
if (digitalRead(plus) == LOW)
    {
    ll1 = ll1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    ll1 = ll1-1;
    delay(150);
    }    
   
if (ll1 > 12) ll1 = 1;
if (ll1 < 1) ll1 = 12;       
     
}  // end loop stare = 5 (change the day as data)

if (nivel == 6)   // change day as data
{
if (digitalRead(menu) == LOW)
  {
  nivel = nivel+1;
  //delay(21);//brett
  tft.fillScreen(ST7735_BLACK);
 tft.fillRect(10,80,100,18,ST7735_BLACK);      
  }    

printText("SETTING", ST7735_GREEN,10,18,2);  // Temperature Static Text
tft.fillRect(10,35,70,18,ST7735_BLACK);
printText("DAY:", ST7735_GREEN,10,35,2);  // Temperature Static Text
dtostrf(dd1,3, 0, chartemp); 
      tft.fillRect(50,50,70,18,ST7735_BLACK);
      tft.fillRect(10,80,100,18,ST7735_BLACK);  // erase last explication...
      delay(50);
      printText(chartemp, ST7735_WHITE,60,50,2);
      delay(50);
 
if (digitalRead(plus) == LOW)
    {
    dd1 = dd1+1;
    delay(150);
    }
if (digitalRead(minus) == LOW)
    {
    dd1 = dd1-1;
    delay(150);
    }    
    
 // Dawn & Dusk controller. http://andydoz.blogspot.ro/2014_08_01_archive.html
 if (ll == 4 || ll == 5 || ll == 9 || ll == 11) { //30 days hath September, April June and November
    maxday = 30;
  }
  else {
  maxday = 31; //... all the others have 31
  }
  if (ll ==2 && yy % 4 ==0) { //... Except February alone, and that has 28 days clear, and 29 in a leap year.
    maxday = 29;
  }
  if (ll ==2 && ll % 4 !=0) {
    maxday = 28;
  }

if (dd1 > maxday) dd1 = 1;
if (dd1 < 1) dd1 = maxday;       
     
}  // end loop nivel = 6 (change the day as data)


 if (nivel >=7)  // readfy to return to main loop
 {
  setDS3231time(0, mm1, hh1, zz1, dd1, ll1, yy1);
 // EEPROM.write(100, hha);
 // EEPROM.write(101, mma);
 // EEPROM.write(102, al%2);
  
  nivel = 0;  
  previousTemperature= 0.0;
  previousHumidity= 0;
  previousmaxTemperature = 0;
  previousminTemperature = 200;
  backlightcount = 0;// sets backlight timer to start of count
  backlightOn = true; //turns on backlight timer
  
  initial = 1;
  tft.fillRect(0,0,119,159,ST7735_BLACK);//Brett blanks screen
 
  temphumidread(); // reads temp/humidity on exit of menu
    
   
 }


 
}  // end main loop


void printText(char *text, uint16_t color, int x, int y,int textSize)
{
  tft.setCursor(x, y);
  tft.setTextColor(color);
  tft.setTextSize(textSize);
  tft.setTextWrap(true);
  tft.print(text);
}

String getDayOfWeek(int i)
{
  switch(i)
  {
    case 0: return "Monday";break;
    case 1: return "Tuesday";break;
    case 2: return "Wednesday";break;
    case 3: return "Thursday";break;
    case 4: return "Friday";break;
    case 5: return "Saturday";break;
    case 6: return "Sunday";break;
    default: return "Monday";break;
  }
}


// http://forum.arduino.cc/index.php?topic=398891.0
void setDS3231time(byte second, byte minute, byte hour, byte dayOfWeek, byte
                   dayOfMonth, byte month, byte year)
{
    // sets time and date data to DS3231
    Wire.beginTransmission(DS3231_I2C_ADDRESS);
    Wire.write(0); // set next input to start at the seconds register
    Wire.write(decToBcd(second)); // set seconds
    Wire.write(decToBcd(minute)); // set minutes
    Wire.write(decToBcd(hour)); // set hours
    Wire.write(decToBcd(dayOfWeek)); // set day of week (1=Sunday, 7=Saturday)
    Wire.write(decToBcd(dayOfMonth)); // set date (1 to 31)
    Wire.write(decToBcd(month)); // set month
    Wire.write(decToBcd(year)); // set year (0 to 99)
    Wire.endTransmission();
}

// Convert binary coded decimal to normal decimal numbers
byte bcdToDec(byte val)
{
    return ( (val / 16 * 10) + (val % 16) );
}

// Convert normal decimal numbers to binary coded decimal
byte decToBcd(byte val)
{
    return ( (val / 10 * 16) + (val % 10) );
}

void readDS3231time(byte *second,
                    byte *minute,
                    byte *hour,
                    byte *dayOfWeek,
                    byte *dayOfMonth,
                    byte *month,
                    byte *year)
{
    Wire.beginTransmission(DS3231_I2C_ADDRESS);
    Wire.write(0); // set DS3231 register pointer to 00h
    Wire.endTransmission();
    Wire.requestFrom(DS3231_I2C_ADDRESS, 7);
    // request seven bytes of data from DS3231 starting from register 00h
    *second = bcdToDec(Wire.read() & 0x7f);
    *minute = bcdToDec(Wire.read());
    *hour = bcdToDec(Wire.read() & 0x3f);
    *dayOfWeek = bcdToDec(Wire.read());
    *dayOfMonth = bcdToDec(Wire.read());
    *month = bcdToDec(Wire.read());
    *year = bcdToDec(Wire.read());
}



// extraPulse
//
// called from <loop>
//================================================================================================================
//steps clock an extra pulse 
void extraPulse(){

 extraLength = 500 - pulseLength; // ensure pulse always start after 500mS
  delay (extraLength);

 
  
  digitalWrite(clockCoil01, coilStatus);
  digitalWrite(clockCoil02, !coilStatus);
   if ( coilStatus == 1 ) // draw rectangles to show coil polarity when on
  { 
    tft.fillRect(65,88,25,7,ST7735_RED);//Brett test Across, Down, Width, Hieght
    tft.fillRect(95,88,25,7,ST7735_BLUE);
  }
  else
  {
    tft.fillRect(65,88,25,7,ST7735_BLUE);//Brett test Across, Down, Width, Hieght
    tft.fillRect(95,88,25,7,ST7735_RED);
  }
  delay(pulseLength);// time extra pulse is on

   digitalWrite(clockCoil01, 0);// then all coils set to off
  digitalWrite(clockCoil02, 0);
  // rectangles go black when both off (0)
  tft.fillRect(65,88,25,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght
  tft.fillRect(95,88,25,7,ST7735_BLACK);
 
  coilStatus = !coilStatus;
} //end of <extraPulse> return to <loop>


//================================================================================================================
//steps clock movement
void pulseCoil(){
 
   
  // coil is energised
  digitalWrite(clockCoil01, coilStatus);
  digitalWrite(clockCoil02, !coilStatus);
  if ( coilStatus == 1 ) // draw rectangles to show coil polarity when on
  { 
    tft.fillRect(65,88,25,7,ST7735_RED);//Brett test Across, Down, Width, Hieght
    tft.fillRect(95,88,25,7,ST7735_BLUE);
    
  }
  else
  {
    tft.fillRect(65,88,25,7,ST7735_BLUE);//Brett test Across, Down, Width, Hieght
    tft.fillRect(95,88,25,7,ST7735_RED);
    
  }

  
 
  // then after the delay turn off 
  
   delay (pulseLength);
   
   //   Note pulsecoil and extrapulse together must not go over 1 second  
 
 //coil off
  digitalWrite(clockCoil01, 0);
  digitalWrite(clockCoil02, 0);
  // rectangles go black when both off (0)
  tft.fillRect(65,88,25,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght
  tft.fillRect(95,88,25,7,ST7735_BLACK);
  
  coilStatus = !coilStatus;
  

} //end of <coilPulse> return to <loop>


//================================================================================================================
//================================================================================================================
//gets advance retard settings from pot
void AdvRtdSettings()
{

 //Print sensor value every second
 AdvRtdVal = analogRead(AdvRtdPin);    // read the value from the sensor
  // serial.print ("Adv/Rtd Value ");
  // serial.println (AdvRtdVal);
//------------------------------------------------


  // Set values for Adv/Rtd Sensor
  if (AdvRtdVal >= 0 && AdvRtdVal < 100) 
  {
   AdvRtdSet = 3600; // Advance retard pulses
   sumwin = true ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("Sm/Wn", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }
 
 else if (AdvRtdVal >= 100 && AdvRtdVal < 180)
 {
   AdvRtdSet = 1; // Advance retard pulses
    sumwin = false ;
   tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("1s", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 180 && AdvRtdVal < 260)
 {
   AdvRtdSet = 10; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("10s", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 260 && AdvRtdVal < 340)
 {
   AdvRtdSet = 30; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("30s", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 340 && AdvRtdVal < 420)
 {
   AdvRtdSet = 60; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("60s", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 420 && AdvRtdVal < 500)
 {
   AdvRtdSet = 300; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("5m", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 500 && AdvRtdVal < 580)
 {
   AdvRtdSet = 600; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("10m", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 580 && AdvRtdVal < 640)
 {
   AdvRtdSet = 900; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("15m", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 640 && AdvRtdVal < 720)
 {
   AdvRtdSet = 1800; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("30m", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 720 && AdvRtdVal < 800)
 {
   AdvRtdSet = 2700; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("45m", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 800 && AdvRtdVal < 880)
 {
   AdvRtdSet = 3600; // Advance retard pulses
   sumwin = false ;
    tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("1hr", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
 }

 else if (AdvRtdVal >= 880 && AdvRtdVal < 1024)

 {
   AdvRtdSet = 21600; // Advance retard pulses
    sumwin = false ;
   tft.fillRect(87,102,40,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("6h", ST7735_GREEN,87,102,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (AdvRtdSet);
  }
}

//================================================================================================================
//gets pulse length settings from preset on A6 This sets the length of motor drive pulse
void PulseSettings()
{

 //Print sensor value every second
 pulsePinval = analogRead(pulsePin);    // read the value from the sensor
  // serial.print ("Adv/Rtd Value ");
  // serial.println (pulsePinval);
//------------------------------------------------


  // Set values for Adv/Rtd Sensor
  if (pulsePinval >= 0 && pulsePinval < 100) 
  {
   pulseLength = 10 ; // Advance retard pulses
   sumwin = true ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 10mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }
 
 else if (pulsePinval >= 100 && pulsePinval < 180)
 {
   pulseLength = 20; // Advance retard pulses
    sumwin = false ;
   tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test DOWN, ACROSS, Width, Hieght####################################
    printText("@ 20mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 180 && pulsePinval < 260)
 {
   pulseLength = 40; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 40mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 260 && pulsePinval < 340)
 {
   pulseLength = 60; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 60mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 340 && pulsePinval < 420)
 {
   pulseLength = 80; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 80mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 420 && pulsePinval < 500)
 {
   pulseLength = 100; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 100mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 500 && pulsePinval < 580)
 {
   pulseLength = 120; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 120mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 580 && pulsePinval < 640)
 {
   pulseLength = 140; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 140mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 640 && pulsePinval < 720)
 {
   pulseLength = 160; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 160mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 720 && pulsePinval < 800)
 {
   pulseLength = 180; // Advance retard pulses
    sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 180mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 800 && pulsePinval < 880)
 {
   pulseLength = 200; // Advance retard pulses
   sumwin = false ;
    tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 200mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
 }

 else if (pulsePinval >= 880 && pulsePinval < 1024)

 {
   pulseLength = 220; // Advance retard pulses
    sumwin = false ;
   tft.fillRect(81,116,46,7,ST7735_BLACK);//Brett test Across, Down, Width, Hieght####################################
    printText("@ 220mS", ST7735_GREEN,81,116,1);  // Temperature Static Text
   // serial.print ("AdvRtd Pulses ");
  // serial.println (pulseLength);
  }




}

// read temperature and humidity every 15mins
void temphumidread()
{
if ( (ss == 15 && (mm == 15 || mm == 30 || mm == 45 || mm == 1) && advance == 0 ) || initialtemp || initial )// read temp & humidity every 1min @ 15seconds past but not when advancing
{
temperature = dht.readTemperature();
umiditate = dht.readHumidity();


// Brett check min max temp

 if ((temperature != previousTemperature) || initial)
  {
    previousTemperature = temperature;
    String temperatureString = String(temperature,1);
    temperatureString.toCharArray(temperatureChar,10);
    tft.fillRect(25,53,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(temperatureChar, ST7735_GREEN,25,53,1); // Across Down Font size 
    printText("o", ST7735_GREEN,49,51,1);
    printText("C", ST7735_GREEN,55,53,1);

  if((umiditate != previousHumidity) || initial)
  {
    previousHumidity = umiditate;
    String umiditateString = String(umiditate);
    umiditateString.toCharArray(umiditateChar,10);
    tft.fillRect(70,53,40,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(umiditateChar, ST7735_GREEN,90,53,1);
    printText("%", ST7735_GREEN,103,53,1);
  }
  }

 if (hh == 0 && mm == 0 && ss == 0)// resets min max temps at midnight
 {
  previousmaxTemperature = 1;
  previousminTemperature = 200;
 }

 
//Brett Temp Min Max
   maxTemperature = temperature ;
 if ((maxTemperature > previousmaxTemperature) || initialtemp)
  {
    previousmaxTemperature = maxTemperature;
    String maxTemperatureString = String(maxTemperature,1);
    maxTemperatureString.toCharArray(charMaxTemperature,10);
    tft.fillRect(25,67,35,7,ST7735_BLACK); // Across, Down, Width, Hieght
    printText(charMaxTemperature, ST7735_RED,25,67,1); // Across Down Font size 
    printText("o", ST7735_RED,49,65,1);
    printText("C", ST7735_RED,55,67,1);
  }
    minTemperature = temperature ;

     
  
  if ((minTemperature < previousminTemperature) || initialtemp )
  {
    previousminTemperature = minTemperature;
     String minTemperatureString = String(minTemperature,1);
    minTemperatureString.toCharArray(charMinTemperature,10);
    tft.fillRect(90,67,25,7,ST7735_BLACK); //Brett test  Across, Down, Width, Hieght
    printText(charMinTemperature, ST7735_BLUE,90,67,1);
    printText("o", ST7735_BLUE,114,65,1);
    printText("C", ST7735_BLUE,120,67,1);
    
  }
 
 initialtemp = 0 ;
}
}

//================================================================================================================
//
